// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.event.*;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import java.lang.reflect.InvocationTargetException;
import java.io.IOException;
import java.util.ResourceBundle;
import java.util.HashMap;
import java.util.Map;


public class AcceptSt2Listener implements ActionListener, MsgSubscriber{

    public final static String FRAMELEN="len";
    public final static String FRAMESRCADDR="srcaddr";
    public final static String FRAMEDSTADDR="dstaddr";
    public final static String DEFAULTADDR="00:00:00:00:00:00";
    public final static int ASKPARAMOFFSET=6;

    private MainWindow window=null;

    public AcceptSt2Listener(MainWindow mainwin){
        window=mainwin;
    }

    public void actionPerformed(ActionEvent evt){
        CommClient commcli=window.getCommClient();
        ResourceBundle bundle=window.getBundle();
        String err=bundle.getString("ERR"), msgerr=null;
        boolean msgsend=false;
        byte[] response=null;

        try{
            commcli.sendMsg(new byte[]{Msg.CAPTURE});
            msgsend=true;
            response=commcli.getResponse();
            if(response[1]==Msg.DOING){
                window.enableAccept(false);
                window.enableCancel(true);
            }else
                throw new IllegalStateException("Error code:" +response[2]);
            
        }catch(IOException io){
            io.printStackTrace(System.err);            
            msgerr=null;
            if(msgsend)
                msgerr=bundle.getString("ERR_NORESPONSE");
            else
                msgerr=bundle.getString("ERR_BREAKCONNECT");

            JOptionPane.showMessageDialog(window, msgerr, err,
                                          JOptionPane.ERROR_MESSAGE);

        }catch(IllegalStateException ile){
            ile.printStackTrace(System.err);            
            msgerr=bundle.getString("ERR_SERVER");
            JOptionPane.showMessageDialog(window, msgerr, err,
                                          JOptionPane.ERROR_MESSAGE);
        }
    }

    public void deliverMsg(byte[] msg){
        CommClient commcli=window.getCommClient();
        ResourceBundle bdle=window.getBundle();        
        byte[] resp=null;        
        boolean msgsend=false;

        try{

            if(msg[0]==Msg.ASK){
            
                if(msg[2]==Msg.TRY_JOIN){
                    String qstmsg=bdle.getString("ASK_CONNECT");
                    RunQuestion rq=new RunQuestion(window, bdle, qstmsg, true);
                    try{
                        SwingUtilities.invokeAndWait(rq);
                    }catch(InterruptedException ie){
                        ie.printStackTrace(System.err);
                    }catch(InvocationTargetException ite){
                        throw new RuntimeException(ite.getCause());
                    }
                    int option=rq.getAnswer();
                    resp=new byte[2];
                    resp[0]=Msg.ANSWER;
                    resp[1]=(option==JOptionPane.NO_OPTION)?Msg.NO : Msg.YES;
                    commcli.sendMsg(resp);
                }else if(msg[2]==Msg.USE_FRAME){
                    int index=ASKPARAMOFFSET, prev=0;
                    HashMap<String,String> params=new HashMap<String,String>();
                    Map.Entry<String,String> entry=null;

                    prev=index;
                    index=MsgOptParser.nextItemSepPos(msg, prev, msg.length);
                    while(index<msg.length){
                        entry=MsgOptParser.nextItem(msg, prev);
                        params.put(entry.getKey(), entry.getValue());
                        prev=index+1;
                        index=MsgOptParser.nextItemSepPos(msg, prev, msg.length);
                    }

                    String tmp=bdle.getString("ASK_CAPFRAME");
                    String len="0";
                    if(params.containsKey(FRAMELEN))
                        len=params.get(FRAMELEN);

                    String dstaddr=DEFAULTADDR;
                    if(params.containsKey(FRAMEDSTADDR))
                        dstaddr=params.get(FRAMEDSTADDR);

                    String srcaddr=DEFAULTADDR;
                    if(params.containsKey(FRAMESRCADDR))
                        srcaddr=params.get(FRAMESRCADDR);

                    String qstmsg=String.format(tmp, len, dstaddr, srcaddr);
                    RunQuestion rq=new RunQuestion(window, bdle, qstmsg, true);
                    try{
                        SwingUtilities.invokeAndWait(rq);
                    }catch(InterruptedException ie){
                        ie.printStackTrace(System.err);
                    }catch(InvocationTargetException ite){
                        throw new RuntimeException(ite.getCause());
                    }
                    int option=rq.getAnswer();
                    resp=new byte[2];
                    resp[0]=Msg.ANSWER;
                    resp[1]=(option==JOptionPane.NO_OPTION)?Msg.NO : Msg.YES;
                    commcli.sendMsg(resp);
                }
            
            }else if(msg[0]==Msg.INFO){

                if(msg[2]==Msg.CANCELLED){
                    Runnable runcancel=null;
                    final String msginf1=bdle.getString("INF_CANC");
                    final String msginf2=bdle.getString("INF_CAPT");
                    runcancel=new Runnable(){
                                    public void run(){
                                        window.enableCancel(false);
                                        window.enableAccept(true);
                                        window.reportUser(MainWindow.TYPEINFO,
                                                          msginf1);
                                        window.reportUser(MainWindow.TYPEINFO,
                                                          msginf2);
                                        }
                                    };
                                    
                    MainWindow.updateWindow(runcancel);
                    
                }else if(msg[2]==Msg.NO_RESPONSE){
                    Runnable runcancel=null;
                    final String msginfo=bdle.getString("INF_CAPT");
                    final String msgerr=bdle.getString("ERR_CAPFRAME");
                    runcancel=new Runnable(){
                                    public void run(){
                                        window.enableCancel(false);
                                        window.enableAccept(true);
                                        window.reportUser(MainWindow.TYPEINFO,
                                                          msgerr);
                                        window.reportUser(MainWindow.TYPEINFO,
                                                          msginfo);
                                        }
                                    };

                    MainWindow.updateWindow(runcancel);
                }else if(msg[2]==Msg.DONE){
                    final String msginfo=bdle.getString("INF_KEYSTR");
                    Runnable done=null;
                    done=new Runnable(){
                                public void run(){
                                    window.reportUser(MainWindow.TYPEINFO,
                                                      msginfo);
                                    try{
                                        window.nextStage();
                                    }catch(IOException io){
                                        IllegalStateException ils=null;
                                        ils=new IllegalStateException(io);
                                        throw ils;
                                    }
                                }
                            };

                    try{
                        MainWindow.updateWindow(done);
                    }catch(IllegalStateException ils){
                        Throwable thle=ils.getCause();
                        if(thle instanceof IOException)
                            throw (IOException)thle;
                        else
                            throw (RuntimeException)thle;
                    }
                }
            }else{
                System.err.println("Unknown capture response: "+
                                   MsgOptParser.reprBytes(msg));
            }

        }catch(IOException io){
            io.printStackTrace(System.err);
            final String err=bdle.getString("ERR");
            String tmp=null;
            msgsend=io.getMessage().indexOf("expired")>0;
            if(msgsend)
                tmp=bdle.getString("ERR_NORESPONSE");
            else
                tmp=bdle.getString("ERR_BREAKCONNECT");

            final String msgerr=tmp;
            Runnable showerr=null;
            showerr=new Runnable(){
                        public void run(){
                            JOptionPane.showMessageDialog(
                                            window, msgerr, err,
                                            JOptionPane.ERROR_MESSAGE); }
                                };
                                
            MainWindow.updateWindow(showerr);

        }catch(IllegalStateException ile){
            ile.printStackTrace(System.err);
            final String err=bdle.getString("ERR");
            final String msgerr=bdle.getString("ERR_SERVER");
            Runnable showerr=null;
            showerr=new Runnable(){
                            public void run(){
                                JOptionPane.showMessageDialog(
                                        window, msgerr, err,
                                        JOptionPane.ERROR_MESSAGE);}
                    };
            
            MainWindow.updateWindow(showerr);
        }
    }

    public int getSource(){
        return ((int)Msg.CAPFRAME) & 0xFF;
    }   
}
