// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.event.*;
import javax.swing.JOptionPane;
import java.io.IOException;
import java.util.ResourceBundle;

public class CancelListener implements ActionListener{

    private MainWindow window=null;
    private String stagemsg=null;
    
    public CancelListener(MainWindow mainwin, String stagemsg){
        this.window=mainwin;
        this.stagemsg=stagemsg;
    }

    public void actionPerformed(ActionEvent evt){
        String err=null, msgerr=null;
        boolean msgsend=false;
        CommClient commcli=window.getCommClient();
        ResourceBundle bundle=window.getBundle();
        byte[] resp=null;

        try{
            commcli.sendMsg(new byte[]{Msg.CANCEL});
            msgsend=true;
            resp=commcli.getResponse();

            if(resp[1]==Msg.NOT_APPLICABLE){
                window.enableAccept(true);
                if(stagemsg!=null)
                    window.reportUser(MainWindow.TYPEINFO, stagemsg);
            }            

            window.enableCancel(false);

        }catch(IOException io){
            io.printStackTrace(System.err);
            err=bundle.getString("ERR");
            msgerr=null;
            if(msgsend)
                msgerr=bundle.getString("ERR_NORESPONSE");
            else
                msgerr=bundle.getString("ERR_BREAKCONNECT");

            JOptionPane.showMessageDialog(window, msgerr, err,
                                          JOptionPane.ERROR_MESSAGE);

        }catch(IllegalStateException ile){
            ile.printStackTrace(System.err);
            err=bundle.getString("ERR");
            msgerr=bundle.getString("ERR_SERVER");
            JOptionPane.showMessageDialog(window, msgerr, err,
                                          JOptionPane.ERROR_MESSAGE);
        }
    }
}
