// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.ResourceBundle;


public class ErrorDialog extends JDialog{

    private ResourceBundle bundle=null;
    private ClientConf config=null;
    private boolean validated=false;
    private JSlider jSretries=null;
    private JSlider jStimeout=null;
    private JButton jBtnok=null;
    private JButton jBtncl=null;

    
    public ErrorDialog(Frame owner, ResourceBundle bundle, ClientConf config){
        super(owner, bundle.getString("MENUERROR"), true);
        this.bundle=bundle;
        this.config=config;
        initComponents();
        initListeners();
        pack();
        setResizable(false);
        setLocationRelativeTo(owner);
        setVisible(true);
    }

    public boolean isValidated(){
        return validated;
    }

    public int getRetries(){
        return jSretries.getValue();
    }

    public int getTimeout(){
        return jStimeout.getValue();
    }

    private void initComponents(){
        Container contentPane=getContentPane();
        contentPane.setLayout(new BorderLayout());
        String label=null;
        
        JPanel jPsld=new JPanel(new GridLayout(2,1,5,5));
        JPanel jPup=new JPanel(new FlowLayout());
        JPanel jPdown=new JPanel(new FlowLayout());
        JPanel jPbtns=new JPanel();
        int defrets=config.getMinRetries();
        int deftime=config.getMinTime();

        label=bundle.getString("LABELRETRIES");
        jPup.setBorder(BorderFactory.createCompoundBorder(
                            BorderFactory.createTitledBorder(label),
                            BorderFactory.createEmptyBorder(5, 5, 5, 5)));
        
        label=bundle.getString("LABELTIMEOUT");
        jPdown.setBorder(BorderFactory.createCompoundBorder(
                            BorderFactory.createTitledBorder(label),
                            BorderFactory.createEmptyBorder(5, 5, 5, 5)));

        jSretries=new JSlider(Limits.MINRETS, Limits.MAXRETS, defrets);
        label=bundle.getString("TIPRETRIES");
        jSretries.setToolTipText(label);
        jSretries.setMajorTickSpacing(3);
        jSretries.setMinorTickSpacing(1);
        jSretries.setPaintTicks(true);
        jSretries.setPaintLabels(true);

        jStimeout=new JSlider(Limits.MINTIME, Limits.MAXTIME, deftime);
        label=bundle.getString("TIPTIMEOUT");
        jStimeout.setToolTipText(label);
        jStimeout.setMajorTickSpacing(10);
        jStimeout.setMinorTickSpacing(5);
        jStimeout.setPaintTicks(true);
        jStimeout.setPaintLabels(true);

        jPup.add(jSretries);
        jPdown.add(jStimeout);
        jPsld.add(jPup);
        jPsld.add(jPdown);
        jPsld.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        contentPane.add(jPsld, BorderLayout.CENTER);

        jPbtns.setLayout(new BoxLayout(jPbtns, BoxLayout.LINE_AXIS));
        label=bundle.getString("BUTTONOK");
        jBtnok=new JButton(label);
        label=bundle.getString("BUTTONCANCEL");
        jBtncl=new JButton(label);
        Dimension d1=null, d2=null;
        d1=jBtnok.getPreferredSize();
        d2=jBtncl.getPreferredSize();

        if(d1.getWidth() > d2.getWidth()){
            jBtnok.setMaximumSize(d1);
            jBtncl.setMaximumSize(d1);
            jBtncl.setPreferredSize(d1);
        }else{
            jBtncl.setMaximumSize(d2);
            jBtnok.setMaximumSize(d2);
            jBtnok.setPreferredSize(d2);
        }

        jPbtns.setBorder(BorderFactory.createEmptyBorder(15, 25, 15, 25));
        jPbtns.add(Box.createHorizontalGlue());
        jPbtns.add(jBtnok);
        jPbtns.add(Box.createRigidArea(new Dimension(30,0)));
        jPbtns.add(jBtncl);
        jPbtns.add(Box.createHorizontalGlue());
        contentPane.add(jPbtns, BorderLayout.SOUTH);
    }

    private void initListeners(){
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        jBtnok.addActionListener(
                new ActionListener(){
                    public void actionPerformed(ActionEvent evt){
                        validated=true;
                        dispose();
                    }
                });

        jBtncl.addActionListener(
                new ActionListener(){
                    public void actionPerformed(ActionEvent evt){
                        dispose();
                    }
        });
    }
}
