// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.awt.event.*;
import java.nio.ByteBuffer;
import java.io.IOException;
import java.util.ResourceBundle;
import javax.swing.JOptionPane;


public class MenuErrorListener implements ActionListener{

    public final static int MAXREQUEST=32;
    public MainWindow window=null;

    public MenuErrorListener(MainWindow mw){
        window=mw;
    }
    
    public void actionPerformed(ActionEvent evt){
        byte[] response=null, request=null;
        ByteBuffer buf=null;
        int reqlen=0, offset=0;
        int retries=0, timeout=0;
        String err=null, errmsg=null;
        ResourceBundle bundle=window.getBundle();
        ClientConf config=window.getConfig();
        ErrorDialog ed=new ErrorDialog(window, bundle, config);

        if(ed.isValidated()){
            request=new byte[MAXREQUEST];
            offset=reqlen++;
            request[offset]=Msg.SET;
            offset=reqlen;

            retries=ed.getRetries();
            buf=MsgOptParser.getBytes(Msg.MINRET);
            buf.rewind();
            reqlen+=buf.remaining();
            buf.get(request, offset, reqlen-offset);
            offset=reqlen++;
            request[offset]=Msg.VALUE_SEP;
            offset=reqlen++;
            request[offset]=(byte)retries;
            offset=reqlen++;
            request[offset]=Msg.ITEM_SEP;
            offset=reqlen;

            timeout=ed.getTimeout();
            buf=MsgOptParser.getBytes(Msg.MINTMO);
            buf.rewind();
            reqlen+=buf.remaining();
            buf.get(request, offset, reqlen-offset);
            offset=reqlen++;
            request[offset]=Msg.VALUE_SEP;
            offset=reqlen++;
            request[offset]=(byte)timeout;
            offset=reqlen++;
            request[offset]=Msg.ITEM_SEP;

            CommClient commcli=window.getCommClient();

            try{
                commcli.sendMsg(request, 0, reqlen);
                response=commcli.getResponse();
                if(response[1]==Msg.SERVER_ERROR){
                    errmsg=bundle.getString("ERR_SERVER");
                }else if(response[1]==Msg.OK){
                    String infomsg=bundle.getString("INF_CONFIG");
                    window.reportUser(MainWindow.TYPEINFO, infomsg);
                    config.setMinRetries(retries);
                    config.setMinTime(timeout);
                }
            }catch(IOException io){
                errmsg=bundle.getString("ERR_BREAKCONNECT");
            }

            if(errmsg!=null){
                err=bundle.getString("ERR");
                JOptionPane.showMessageDialog(window, errmsg, err,
                                            JOptionPane.ERROR_MESSAGE);
            }
        }
    }

}
